package sk.seges.sesam.core.model.converter;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

import javax.annotation.Generated;
import javax.persistence.EntityManager;

import sk.seges.corpis.service.annotation.TransactionPropagationModel;
import sk.seges.sesam.dao.Page;
import sk.seges.sesam.dao.SortInfo;
import sk.seges.sesam.pap.model.annotation.TransferObjectMapping;
import sk.seges.sesam.server.domain.converter.ProjectableResultConverter;
import sk.seges.sesam.shared.model.converter.BasicCachedConverter;
import sk.seges.sesam.shared.model.converter.ConvertedInstanceCache;
import sk.seges.sesam.shared.model.converter.api.ConverterProvider;
import sk.seges.sesam.shared.model.converter.api.DtoConverter;
import sk.seges.sesam.shared.model.converter.common.CollectionConverter;
import sk.seges.sesam.utils.CastUtils;

@SuppressWarnings("serial")
@TransferObjectMapping(dtoClass = Page.class,
		domainClassName = "sk.seges.sesam.dao.Page", 
		configurationClassName = "sk.seges.sesam.core.model.converter.PageConfiguration", 
		generateConverter = false, generateDto = false, 
		converterClassName = "sk.seges.sesam.core.model.converter.PageConverter")
@Generated(value = "sk.seges.corpis.pap.model.hibernate.HibernateTransferObjectConverterProcessor")
public class PageConverter extends BasicCachedConverter<Page, Page> {

	private EntityManager entityManager;

	private TransactionPropagationModel[] transactionPropagations;

	private ConvertedInstanceCache cache;

	private ConverterProvider converterProvider;

	public PageConverter(EntityManager entityManager, TransactionPropagationModel[] transactionPropagations, ConvertedInstanceCache cache, ConverterProvider converterProvider) {
		super(cache);
		this.entityManager = entityManager;
		this.transactionPropagations = transactionPropagations;
		this.cache = cache;
		this.converterProvider = converterProvider;
	}

	public boolean equals(Page _domain, Page _dto) {
		if (_domain.getFilterable() == null) {
			if (_dto.getFilterable() != null)
				return false;
		} else if (!_domain.getFilterable().equals(_dto.getFilterable()))
			return false;
		if (_domain.getPageSize() != _dto.getPageSize())
			return false;
		if (_domain.getProjectableResult() == null) {
			if (_dto.getProjectableResult() != null)
				return false;
		} else if (!_domain.getProjectableResult().equals(_dto.getProjectableResult()))
			return false;
		if (_domain.getProjectables() == null) {
			if (_dto.getProjectables() != null)
				return false;
		} else if (!_domain.getProjectables().equals(_dto.getProjectables()))
			return false;
		if (_domain.getSortables() == null) {
			if (_dto.getSortables() != null)
				return false;
		} else if (!_domain.getSortables().equals(_dto.getSortables()))
			return false;
		if (_domain.getStartIndex() != _dto.getStartIndex())
			return false;
		return true;
	}

	public Page createDtoInstance(Serializable id) {
		Page _result = new Page();
		return _result;
	}

	public Page toDto(Page _domain) {

		if (_domain  == null) {
			return null;
		}

		Page _result = createDtoInstance(null);
		return convertToDto(_result, _domain);
	}

	public Page convertToDto(Page _result, Page _domain) {

		if (_domain  == null) {
			return null;
		}

		_result.setFilterable(_domain.getFilterable());
		_result.setPageSize(_domain.getPageSize());
		ProjectableResultConverter converterProjectableResult = ensureDomainProjectableResultConverter((String)_domain.getProjectableResult());
		_result.setProjectableResult(converterProjectableResult.toDto(CastUtils.cast((String)_domain.getProjectableResult(), String.class)));
		CollectionConverter<String, String> converterProjectables = ((CollectionConverter)ensureDomainCollectionConverter(_domain.getProjectables()));
		_result.setProjectables(converterProjectables.toDto(CastUtils.cast((List<?>)_domain.getProjectables(), String.class), java.util.ArrayList.class));
		CollectionConverter<SortInfo, SortInfo> converterSortables = ((CollectionConverter)ensureDomainCollectionConverter(_domain.getSortables()));
		_result.setSortables(converterSortables.toDto(CastUtils.cast((List<?>)_domain.getSortables(), SortInfo.class), java.util.ArrayList.class));
		_result.setStartIndex(_domain.getStartIndex());
		return _result;
	}

	public Page createDomainInstance(Serializable id) {
		if (id != null) {
			Page _result = (Page)entityManager.find(Page.class, id);
			if (_result != null) {
				return _result;
			}
		}

		 return new Page();
	}

	public Page fromDto(Page _dto) {

		if (_dto == null) {
			return null;
		}

		Page _result = createDomainInstance(null);

		return convertFromDto(_result, _dto);
	}

	public Page convertFromDto(Page _result, Page _dto) {

		if (_dto  == null) {
			return null;
		}

		_result.setFilterable(_dto.getFilterable());
		_result.setPageSize(_dto.getPageSize());
		ProjectableResultConverter converterProjectableResult = ensureDtoProjectableResultConverter((String)_dto.getProjectableResult());
		_result.setProjectableResult(CastUtils.cast((String)converterProjectableResult.fromDto((String)_dto.getProjectableResult()), String.class));
		CollectionConverter<String, String> converterProjectables = ((CollectionConverter)ensureDtoCollectionConverter(_dto.getProjectables()));
		_result.setProjectables(CastUtils.cast((List<?>)converterProjectables.fromDto((List<String>)_dto.getProjectables()), String.class));
		CollectionConverter<SortInfo, SortInfo> converterSortables = ((CollectionConverter)ensureDtoCollectionConverter(_dto.getSortables()));
		_result.setSortables(CastUtils.cast((List<?>)converterSortables.fromDto((List<SortInfo>)_dto.getSortables()), SortInfo.class));
		_result.setStartIndex(_dto.getStartIndex());
		return _result;
	}

	protected ProjectableResultConverter ensureDomainProjectableResultConverter(String obj) {
		if (obj == null) {
			return (ProjectableResultConverter) ensureDomainProjectableResultConverter((Class<? extends String>)null);
		}

		return (ProjectableResultConverter) ensureDomainProjectableResultConverter(obj.getClass());
	}
	
	protected ProjectableResultConverter ensureDomainProjectableResultConverter(Class<? extends String> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDomain(objClass, cache);
		if (converter != null) {
			return (ProjectableResultConverter) converter;
		}
		return getDomainProjectableResultConverter(objClass);
	}

	protected ProjectableResultConverter ensureDtoProjectableResultConverter(String obj) {
		if (obj == null) {
			return (ProjectableResultConverter) ensureDtoProjectableResultConverter((Class<? extends String>)null);
		}

		return (ProjectableResultConverter) ensureDtoProjectableResultConverter(obj.getClass());
	}
	
	protected ProjectableResultConverter ensureDtoProjectableResultConverter(Class<? extends String> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDto(objClass, cache);
		if (converter != null) {
			return (ProjectableResultConverter) converter;
		}
		return getDtoProjectableResultConverter(objClass);
	}

	protected ProjectableResultConverter getDomainProjectableResultConverter(Class<? extends String> objClass){
		return new ProjectableResultConverter(converterProvider);
	}

	protected ProjectableResultConverter getDtoProjectableResultConverter(Class<? extends String> objClass){
		return new ProjectableResultConverter(converterProvider);
	}

	protected <DTO extends String, DOMAIN extends String> CollectionConverter<DTO, DOMAIN> ensureDomainCollectionConverter(Collection<?> obj) {
		if (obj == null) {
			return (CollectionConverter<DTO, DOMAIN>) ensureDomainCollectionConverter((Class<? extends Collection<?>>)null);
		}

		return (CollectionConverter<DTO, DOMAIN>) ensureDomainCollectionConverter((Class<? extends Collection<?>>)obj.getClass());
	}
	
	protected <DTO extends String, DOMAIN extends String> CollectionConverter<DTO, DOMAIN> ensureDomainCollectionConverter(Class<? extends Collection<?>> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDomain(objClass, cache);
		if (converter != null) {
			return (CollectionConverter<DTO, DOMAIN>) converter;
		}
		return getDomainCollectionConverter(objClass);
	}

	protected <DTO extends String, DOMAIN extends String> CollectionConverter<DTO, DOMAIN> ensureDtoCollectionConverter(Collection<?> obj) {
		if (obj == null) {
			return (CollectionConverter<DTO, DOMAIN>) ensureDtoCollectionConverter((Class<? extends Collection<?>>)null);
		}

		return (CollectionConverter<DTO, DOMAIN>) ensureDtoCollectionConverter((Class<? extends Collection<?>>)obj.getClass());
	}
	
	protected <DTO extends String, DOMAIN extends String> CollectionConverter<DTO, DOMAIN> ensureDtoCollectionConverter(Class<? extends Collection<?>> objClass) {
		DtoConverter<?, ?> converter = converterProvider.getConverterForDto(objClass, cache);
		if (converter != null) {
			return (CollectionConverter<DTO, DOMAIN>) converter;
		}
		return getDtoCollectionConverter(objClass);
	}

	protected <DTO extends String, DOMAIN extends String> CollectionConverter<DTO, DOMAIN> getDomainCollectionConverter(Class<? extends Collection<?>> objClass){
		return new CollectionConverter<DTO, DOMAIN>(cache, converterProvider);
	}

	protected <DTO extends String, DOMAIN extends String> CollectionConverter<DTO, DOMAIN> getDtoCollectionConverter(Class<? extends Collection<?>> objClass){
		return new CollectionConverter<DTO, DOMAIN>(cache, converterProvider);
	}

}